from CvPythonExtensions import *
import PyHelpers
import Spreads
gc = CyGlobalContext()
PyInfo = PyHelpers.PyInfo
PyPlayer = PyHelpers.PyPlayer
lGameAnimals = []
lGamePlants = [] 


class AnimalSpawning:




	def __init__(self):
		## Animal generation stuff
		self.baseTilesPerPlant = 4
		self.baseTilesPerPrey = 7
		self.baseTilesPerPredator = 60
		##Food Regeneration Amounts (in percent)
		self.foodLarge = 70
		self.foodMedium = 40
		self.foodSmall = 20
		##Animal Reproduction Chances
		self.reproduceSmall = 10  ## this will occur roughly once a year
		self.reproduceMedium = 20  ## roughly twice a year
		self.reproduceBig = 40  ##roughly four times a year
		self.reproduceHuge = 80  ##almost every turn during the right seasons


		## This is used to determine how many unique species to place on each continent
		self.iSpeciesPerContinent = 3
		## Must have this many tiles to be considered a valid category
		self.iMinCategorySize = 10

		## These are the categories for animals to spawn in. 
		self.lColdTerrains = [gc.getInfoTypeForString("TERRAIN_TUNDRA"),gc.getInfoTypeForString("TERRAIN_SNOW")]
		self.lColdFeatures = [gc.getInfoTypeForString("FEATURE_ICE")]
		self.lMildTerrains = [gc.getInfoTypeForString("TERRAIN_PLAINS"),gc.getInfoTypeForString("TERRAIN_GRASS")]
		self.lMildFeatures = [gc.getInfoTypeForString("FEATURE_FOREST")]
		self.lHotTerrains = [gc.getInfoTypeForString("TERRAIN_DESERT")]
		self.lHotFeatures = [gc.getInfoTypeForString("FEATURE_JUNGLE"),gc.getInfoTypeForString("FEATURE_OASIS")]



	#def initializeAnimals(self):
	#    ##have a list of terrains and features, with each terrain/feature having a list of animals
		#   sFilePath = "Mods/Dynamica/Assets/Modules/Animals/Animals_CIV4UntInfos.xml"
		#  MyFile = open(sFilePath)
		# CurEvent = []
		#for sCurrent in MyFile.readlines():
			#   if "<UnitType>" in sCurrent:
			#      UnitString = CutString(sCurrent)
			#     self.animalList.append(UnitString)
			#elif "<"

	def CutString(string):
		string = string[string.find(">") + 1:]
		string = string[:string.find("<")]
		return string
		
	def doInitialSpawning(self):
		mMap = gc.getMap()
		### Okay first we're going to spawn every single unit in the game onto the tile 1,1
		### But we have to make sure that tile is empty
		iX = 1
		iY = 1
		pPlot = mMap.plot(iX,iY)
		#bFoundPlot = True
		#if pPlot.getNumUnits > 0:
			#bFoundPlot = False
		#while (bFoundPlot == False):
			#iX += 1
			#pPlot = mMap.plot(iX, iY)
			#if pPlot.getNumUnits > 0:
				#bFoundPlot = False
			#else:
				#bFoundPlot = True
		### Now we should have an empty tile to mess with; let's spawn a fetch ton of barbarians on it
		### For each one, see if it's an animal
		### If it is, add its info to a list
		### Either way, kill it off afterward
		pBarb = gc.getPlayer(gc.getBARBARIAN_PLAYER())
		lPredatorUnits = []
		lPreyUnits = []
		lPlantUnits = []
		for i in range(gc.getNumUnitInfos()):
			pNewUnit = pBarb.initUnit(i,iX,iY,UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
			unitInfo = gc.getUnitInfo(pNewUnit.getUnitType())
			if pNewUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_PREY")):
				lPreyUnits.append(unitInfo)                
			elif pNewUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_PREDATOR")):
				lPredatorUnits.append(unitInfo)
			elif pNewUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_PLANT")):
				lPlantUnits.append(unitInfo) 

			pNewUnit.kill(False, gc.getBARBARIAN_PLAYER())

		## The animal lists are now full
		## Each line has a unitInfo, its index (for spawning it later), and bPlaced = False

		### So now, we turn our focus to continents.
		iContinents = mMap.getNumLandAreas()
		iMinSpecies = iContinents * self.iSpeciesPerContinent
		iPredatorSpecies = len(lPredatorUnits)
		iPreySpecies = len(lPreyUnits)
		iPlantSpecies = len(lPlantUnits)
		iSpawnNumPred = 1
		iSpawnNumPrey = 1
		iSpawnNumPlnt = 1
		if iPredatorSpecies > iMinSpecies:
			iSpawnNumPred = iPredatorSpecies / iMinSpecies
		if iPreySpecies > iMinSpecies:
			iSpawnNumPrey = iPreySpecies / iMinSpecies
		if iPlantSpecies > iMinSpecies:
			iSpawnNumPlnt = iPlantSpecies / iMinSpecies
		lColdPredators = []
		lMildPredators = []
		lHotPredators = []
		if len(lPredatorUnits) > 0:
			for i in range(len(lPredatorUnits)):
				unit = lPredatorUnits[i]
				category = self.getAnimalCategory(unit)
				if category == "Cold":
					lColdPredators.append(unit)
				elif category == "Mild":
					lMildPredators.append(unit)
				else: 
					lHotPredators.append(unit)
		lColdPlants = []
		lMildPlants = []
		lHotPlants = []
		if len(lPlantUnits) > 0:
			for i in range(len(lPlantUnits)):
				unit = lPlantUnits[i]
				category = self.getAnimalCategory(unit)
				if category == "Cold":
					lColdPlants.append(unit)
				elif category == "Mild":
					lMildPlants.append(unit)
				else: 
					lHotPlants.append(unit)
		lColdPrey = []
		lMildPrey = []
		lHotPrey = []
		if len(lPreyUnits) > 0:
			for i in range(len(lPreyUnits)):
				unit = lPreyUnits[i]
				category = self.getAnimalCategory(unit)
				if category == "Cold":
					lColdPrey.append(unit)
				elif category == "Mild":
					lMildPrey.append(unit)
				else: 
					lHotPrey.append(unit)        
		##Now the animals are divided into categories based on type
		##and also categories based on temperature. 
		##So we'll go to each continent, figure out what temperatures it has
		##And spawn some animal species. 

		lColdTiles = []
		lMildTiles = []
		lHotTiles = []
		lContinentIDs = []
		for i in range(iContinents):
			lColdTiles.append([0])
			lMildTiles.append([0])
			lHotTiles.append([0])
		for x in range(mMap.getGridWidth()):
			for y in range(mMap.getGridHeight()):
				pTile = mMap.plot(x,y)
				## So it turns out each continent has a unique id and is not known by its integer index.
				## So in order to sort tiles by continent, we need to figure out the tile's continent's id
				iArea = pTile.getArea()
				index = -1
				## Let's see if we've already found this continent
				## If so, the tile will sort into that continent's cold/hot/warm tiles
				if iArea in lContinentIDs:
					index = lContinentIDs.index(iArea)
				## If not, need to make a new entry for that continent
				elif not pTile.isWater():
					lContinentIDs.append(iArea) 
					index = lContinentIDs.index(iArea)

				if index > -1:
					if pTile.getTerrainType() in self.lColdTerrains:
						lColdTiles[index].append(pTile)
					elif pTile.getFeatureType() in self.lColdFeatures:
						lColdTiles[index].append(pTile)
					elif pTile.getTerrainType() in self.lMildTerrains:
						lMildTiles[index].append(pTile)
					elif pTile.getFeatureType() in self.lMildFeatures:
						lMildTiles[index].append(pTile)
					if pTile.getTerrainType() in self.lHotTerrains:
						lHotTiles[index].append(pTile)
					elif pTile.getFeatureType() in self.lHotFeatures:
						lHotTiles[index].append(pTile)

		## now we have the tiles sorted by continent and category        


		## let's add all the players we'll need.    
		## you can optionally move this next bit into the for loop below;
		## in that case you'd have separate plant/prey/pred players for each continent.
		## I don't see much of a point though. 
		iPlayers = CyGame().countCivPlayersAlive()
		iPlantsPlayer = iPlayers + 1
		iPreyPlayer = iPlayers + 2
		iPredatorsPlayer = iPlayers + 3
		CyGame().addPlayer(iPlantsPlayer,gc.getInfoTypeForString("LEADER_BARBARIAN"),gc.getInfoTypeForString("CIVILIZATION_PLANTS"))
		CyGame().addPlayer(iPreyPlayer,gc.getInfoTypeForString("LEADER_BARBARIAN"),gc.getInfoTypeForString("CIVILIZATION_PREY"))
		CyGame().addPlayer(iPredatorsPlayer,gc.getInfoTypeForString("LEADER_BARBARIAN"),gc.getInfoTypeForString("CIVILIZATION_PREDATORS"))
		pPlantsPlayer = gc.getPlayer(iPlantsPlayer)
		pPreyPlayer = gc.getPlayer(iPreyPlayer)
		pPredatorsPlayer = gc.getPlayer(iPredatorsPlayer)
		iPlantsTeam = pPlantsPlayer.getTeam()
		iPreyTeam = pPreyPlayer.getTeam()
		iPredatorTeam = pPredatorsPlayer.getTeam()
		pPredatorTeam = gc.getTeam(iPredatorTeam)
		pPreyTeam = gc.getTeam(iPreyTeam)
		pPlantsTeam = gc.getTeam(iPlantsTeam)
		pPlantsTeam.declareWar(iPreyTeam, False, -1)
		pPreyTeam.declareWar(iPredatorTeam, False, -1)
		## Now we need them to declare war on all the other players
		iTotalPlayers = CyGame().countCivPlayersAlive()
		for iPlayer in range(iTotalPlayers):
			pPlayer = gc.getPlayer(iPlayer)
			iTeam = pPlayer.getTeam()
			pTeam = gc.getTeam(iTeam)
			if iPlantsPlayer == iPlayer: continue
			else:
				pTeam.declareWar(iPlantsTeam, False, -1)
				pPlantsTeam.setPermanentWarPeace(iTeam, True)
			if iPreyPlayer == iPlayer: continue
			else:
				pTeam.declareWar(iPreyTeam, False, -1)
				pPreyTeam.setPermanentWarPeace(iTeam, True)
			if iPredatorsPlayer == iPlayer: continue
			else:
				pPredatorTeam.declareWar(iTeam, False, 6)
				pPredatorTeam.setPermanentWarPeace(iTeam, True)

		## if that worked, the animal players should be at war with everyone
		## including each other
		## and it should be permanent.



		for i in range(len(lContinentIDs)):
			pContinent = mMap.getArea(lContinentIDs[i])
			iTiles = pContinent.getNumTiles()
			iColds = len(lColdTiles[i])
			iMilds = len(lMildTiles[i])
			iHots = len(lHotTiles[i])
			bCold = False
			bMild = False
			bHot = False
			if iColds > self.iMinCategorySize:
				bCold = True
			if iMilds > self.iMinCategorySize:
				bMild = True
			if iHots > self.iMinCategorySize:
				bHot = True





			for j in range(iSpawnNumPlnt):
				## Select a species, if one is available
				iNum = len(lColdPlants)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					plantInfo = lColdPlants[iWhich]
					## Figure out how many to initially spawn
					iPlants = iColds / self.baseTilesPerPlant
					## Spawn them in tiles selected randomly from the list
					for p in range(iPlants):
						iWhichTile = CyGame().getSorenRandNum(iColds, "which")
						pPlot = lColdTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPlantsPlayer.initUnit(gc.getInfoTypeForString(plantInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				## Select a species, if one is available
				iNum = len(lMildPlants)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					plantInfo = lMildPlants[iWhich]
					## Figure out how many to initially spawn
					iPlants = iMilds / self.baseTilesPerPlant
					## Spawn them in tiles selected randomly from the list
					for p in range(iPlants):
						iWhichTile = CyGame().getSorenRandNum(iMilds, "which")
						pPlot = lMildTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPlantsPlayer.initUnit(gc.getInfoTypeForString(plantInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				## Select a species, if one is available
				iNum = len(lHotPlants)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					plantInfo = lHotPlants[iWhich]
					## Figure out how many to initially spawn
					iPlants = iHots / self.baseTilesPerPlant
					## Spawn them in tiles selected randomly from the list
					for p in range(iPlants):
						iWhichTile = CyGame().getSorenRandNum(iHots, "which")
						pPlot = lHotTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPlantsPlayer.initUnit(gc.getInfoTypeForString(plantInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
			for j in range(iSpawnNumPrey):
				## Select a species, if one is available
				iNum = len(lColdPrey)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					preyInfo = lColdPrey[iWhich]
					## Figure out how many to initially spawn
					iPrey = iColds / self.baseTilesPerPrey
					## Spawn them in tiles selected randomly from the list
					for p in range(iPrey):
						iWhichTile = CyGame().getSorenRandNum(iColds, "which")
						pPlot = lColdTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPreyPlayer.initUnit(gc.getInfoTypeForString(preyInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				## Select a species, if one is available
				iNum = len(lMildPrey)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					preyInfo = lMildPrey[iWhich]
					## Figure out how many to initially spawn
					iPrey = iMilds / self.baseTilesPerPrey
					## Spawn them in tiles selected randomly from the list
					for p in range(iPrey):
						iWhichTile = CyGame().getSorenRandNum(iMilds, "which")
						pPlot = lMildTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPreyPlayer.initUnit(gc.getInfoTypeForString(preyInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				## Select a species, if one is available
				iNum = len(lHotPrey)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					preyInfo = lHotPrey[iWhich]
					## Figure out how many to initially spawn
					iPrey = iHots / self.baseTilesPerPrey
					## Spawn them in tiles selected randomly from the list
					for p in range(iPrey):
						iWhichTile = CyGame().getSorenRandNum(iHots, "which")
						pPlot = lHotTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPreyPlayer.initUnit(gc.getInfoTypeForString(preyInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
			for j in range(iSpawnNumPred):
				## Select a species, if one is available
				iNum = len(lColdPredators)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					predatorInfo = lColdPredators[iWhich]
					## Figure out how many to initially spawn
					iPredators = iColds / self.baseTilesPerPredator
					## Spawn them in tiles selected randomly from the list
					for p in range(iPredators):
						iWhichTile = CyGame().getSorenRandNum(iColds, "which")
						pPlot = lColdTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPredatorsPlayer.initUnit(gc.getInfoTypeForString(predatorInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				## Select a species, if one is available
				iNum = len(lMildPredators)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					predatorInfo = lMildPredators[iWhich]
					## Figure out how many to initially spawn
					iPredators = iMilds / self.baseTilesPerPredator
					## Spawn them in tiles selected randomly from the list
					for p in range(iPredators):
						iWhichTile = CyGame().getSorenRandNum(iMilds, "which")
						pPlot = lMildTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPredatorsPlayer.initUnit(gc.getInfoTypeForString(predatorInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				## Select a species, if one is available
				iNum = len(lHotPredators)
				if iNum > 0:
					iWhich = CyGame().getSorenRandNum(iNum, "which")
					predatorInfo = lHotPredators[iWhich]
					## Figure out how many to initially spawn
					iPredators = iHots / self.baseTilesPerPredator
					## Spawn them in tiles selected randomly from the list
					for p in range(iPredators):
						iWhichTile = CyGame().getSorenRandNum(iHots, "which")
						pPlot = lHotTiles[i][iWhichTile]
						try:
							pPlot.getX()
						except:
							continue                        
						if mMap.isPlot(pPlot.getX(),pPlot.getY()) and not pPlot.isPeak():
							pPredatorsPlayer.initUnit(gc.getInfoTypeForString(predatorInfo.getType()),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)










		## Everything below here is the never-used system. Version 2.
		## It was far too complicated to debug. 


		#lContinents = [] 
		#lTileList = [] ##going to use this in a sec
		#lTerrains = []
		#lFeatures = []
		#for i in xrange(iContinents):
			#pArea = mMap.getArea(i)
			#iLandPlots = pArea.getNumTiles()
			#lContinents.append([i])
			#lContinents[i].append(iLandPlots)
			### Let's put the terrain types in the continent list

			#lContinents[i].append(lTileList)

			#for iFeature in xrange(gc.getNumFeatureInfos()):
				#lFeatures.append(0)

			#lTerrains.append(lFeatures)
			#for iTerrains in xrange(gc.getNumTerrainInfos()):
				#lContinents[i].append(lTerrains)





		### Now each continent has a list for each terrain and feature type to sort tiles by

		#### Time to sort the tiles by continent.
		#for x in xrange(mMap.getGridWidth()):
			#for y in xrange(mMap.getGridHeight()):
				#pTile = mMap.plot(x,y)
				#iAreaID = pTile.area().getID()
				#lContinents[iAreaID][1].append(pTile)
				#iListTerrainIndex = pTile.getTerrainType() - 2
				#iListFeatureIndex = pTile.getFeatureType() + 1
				#lContinents[iAreaID][iListTerrainIndex][iListFeatureIndex] += 1

		### Now each continent has a list of its tiles, and numbers of each terrain/feature
		### So we figure out which animals go on which continents, and then spawn them there.
		### First we need to make sure the players owning the animals actually exist.
		### We will add three players as minor civs.
		#iPlayers = CyGame().countCivPlayersAlive()
		#iPlantsPlayer = iPlayers + 1
		#iPreyPlayer = iPlayers + 2
		#iPredatorsPlayer = iPlayers + 3
		#CyGame().addPlayer(iPlantsPlayer,gc.getInfoTypeForString("LEADER_BARBARIAN"),gc.getInfoTypeForString("CIVILIZATION_PLANTS"))
		#CyGame().addPlayer(iPreyPlayer,gc.getInfoTypeForString("LEADER_BARBARIAN"),gc.getInfoTypeForString("CIVILIZATION_PREY"))
		#CyGame().addPlayer(iPredatorsPlayer,gc.getInfoTypeForString("LEADER_BARBARIAN"),gc.getInfoTypeForString("CIVILIZATION_PREDATORS"))
		#pPlantsPlayer = gc.getPlayer(iPlantsPlayer)
		#pPreyPlayer = gc.getPlayer(iPreyPlayer)
		#pPredatorsPlayer = gc.getPlayer(iPredatorsPlayer)



		### Now the tricky part: actually spawning animals
		### First we're going to sort animals into lists based on where they can spawn.
		#lComboPreds = []
		#lComboPreys = []
		#lComboPlants = []
		#for iTerrain in range(gc.getNumTerrainInfos()):
			#lComboPreds.append([])
			#lComboPreys.append([])
			#lComboPlants.append([])
			#for iFeature in range(gc.getNumFeatureInfos() + 1):
				#lPreds = []
				#lPreys = []
				#lPlants = []
				#for iPred in range(len(lPredatorUnits)):
					#info = lPredatorUnits[iPred][0]
					#if self.isSpawnSpot(info, iTerrain, iFeature):
						#lPreds.append(iPred)
				#for iPrey in range(len(lPreyUnits)):
					#info = lPreyUnits[iPrey][0]
					#if self.isSpawnSpot(info, iTerrain, iFeature):
						#iPreys.append(iPrey)
				#for iPlant in range(len(lPlantUnits)):
					#info = lPlantUnits[iPlant][0]
					#if self.isSpawnSpot(info, iTerrain, iFeature):
						#lPlants.append(iPlant)
				#lComboPlants[iTerrain].append(lPlants)
				#lComboPreys[iTerrain].append(lPreys)
				#lComboPreds[iTerrain].append(lPreds)
		### Now we have three lists full of animals at each terrain/feature combo


		### Time to begin the spawning
		#for iContinent in range(len(lContinents)):
			#fTiles = float(len(lContinents[iContinent][1]))
			#fTotalTiles = float(iMapTotalLand)


			### Predators first
			#iPredTypes = int((fTiles / fTotalTiles) * float(len(lPredatorUnits)))
			### My current idea is to just figure out the number of species, then pick each species, spawn a bunch, and move on to the next one
			#iTilesPerPredator = self.baseTilesPerPredator * iPredTypes
			#for i in range(iPredTypes):
				#iPredSpawns = fTiles / iTilesPerPredator
				#bigEnough = False
				#tries = 0
				#while(not bigEnough):
					#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
					#iFeat = tile.getFeatureType()
					#iTerr = tile.getTerrainType()
					#if lContinents[iContinent][iTerr + 2][iFeat + 1] > iPredSpawns:
						#bigEnough = True
					#elif tries > 30:
						#bigEnough = True
				#avails = lComboPreds[iTerr][iFeat+1]
				#animal = avails[gc.getSorenRandNum(len(avails),"which animal to spawn a bunch of")]
				#for i in range(iPredSpawns):
					### Select a random tile from the continent
					#canspawnhere = False
					#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
					#while (not canspawnhere):
						#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
						#iFeat = tile.getFeatureType()
						#iTerr = tile.getTerrainType()
						#canspawnhere = self.isSpawnSpot(lPredatorUnits[animal][0], iTerr, iFeat)
					#pPredatorsPlayer.initUnit(lPredatorUnits[animal][1],tile.getX(),tile.getY(),UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)

			### Now plants
			#iPlantTypes = int((fTiles / fTotalTiles) * float(len(lPlantUnits)))
			### My current idea is to just figure out the number of species, then pick each species, spawn a bunch, and move on to the next one
			#iTilesPerPlant = self.baseTilesPerPlant * iPlantTypes
			#for i in range(iPlantTypes):
				#iPlantSpawns = fTiles / iTilesPerPlant
				#bigEnough = False
				#tries = 0
				#while(not bigEnough):
					#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
					#iFeat = tile.getFeatureType()
					#iTerr = tile.getTerrainType()
					#if lContinents[iContinent][iTerr + 2][iFeat + 1] > iPlantSpawns:
						#bigEnough = True
					#elif tries > 30:
						#bigEnough = True
				#avails = lComboPlants[iTerr][iFeat+1]
				#animal = avails[gc.getSorenRandNum(len(avails),"which animal to spawn a bunch of")]
				#for i in range(iPlantSpawns):
					### Select a random tile from the continent
					#canspawnhere = False
					#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
					#while (not canspawnhere):
						#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
						#iFeat = tile.getFeatureType()
						#iTerr = tile.getTerrainType()
						#canspawnhere = self.isSpawnSpot(lPlantUnits[animal][0], iTerr, iFeat)
					#pPlantsPlayer.initUnit(lPlantUnits[animal][1],tile.getX(),tile.getY(),UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)

			### Now prey
			#iPreyTypes = int((fTiles / fTotalTiles) * float(len(lPreyUnits)))
			### My current idea is to just figure out the number of species, then pick each species, spawn a bunch, and move on to the next one
			#iTilesPerPrey = self.baseTilesPerPrey * iPreyTypes
			#for i in range(iPreyTypes):
				#iPreySpawns = fTiles / iTilesPerPrey
				#bigEnough = False
				#tries = 0
				#while(not bigEnough):
					#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
					#iFeat = tile.getFeatureType()
					#iTerr = tile.getTerrainType()
					#if lContinents[iContinent][iTerr + 2][iFeat + 1] > iPreySpawns:
						#bigEnough = True
					#elif tries > 30:
						#bigEnough = True
				#avails = lComboPreys[iTerr][iFeat+1]
				#animal = avails[gc.getSorenRandNum(len(avails),"which animal to spawn a bunch of")]
				#for i in range(iPreySpawns):
					### Select a random tile from the continent
					#canspawnhere = False
					#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
					#while (not canspawnhere):
						#tile = lContinents[iContinent][1][gc.getSorenRandNum(len(lContinents[iContinent][1],"tile to spawn in"))]
						#iFeat = tile.getFeatureType()
						#iTerr = tile.getTerrainType()
						#canspawnhere = self.isSpawnSpot(lPreyUnits[animal][0], iTerr, iFeat)
					#pPreyPlayer.initUnit(lPreyUnits[animal][1],tile.getX(),tile.getY(),UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)


	def getAnimalCategory(self, unitInfo):
		sCategory = "None"
		for iTerrain in self.lColdTerrains:
			if unitInfo.getTerrainNative(iTerrain):
				sCategory = "Cold"
				return sCategory
		for iFeature in self.lColdFeatures:
			if unitInfo.getFeatureNative(iFeature):
				sCategory = "Cold"
				return sCategory
		for iTerrain in self.lMildTerrains:
			if unitInfo.getTerrainNative(iTerrain):
				sCategory = "Mild"
				return sCategory
		for iFeature in self.lMildFeatures:
			if unitInfo.getFeatureNative(iFeature):
				sCategory = "Mild"
				return sCategory
		for iTerrain in self.lHotTerrains:
			if unitInfo.getTerrainNative(iTerrain):
				sCategory = "Hot"
				return sCategory
		for iFeature in self.lHotFeatures:
			if unitInfo.getFeatureNative(iFeature):
				sCategory = "Hot"
				return sCategory        




	def isSpawnSpot(self, unitInfo, iTerr, iFeat):
		if unitInfo.getTerrainImpassable(iTerr):
			return False
		elif unitInfo.getFeatureImpassable(iFeat):
			return False
		elif unitInfo.getTerrainNative(iTerr) or unitInfo.getFeatureNative(iFeat):
			return True
		else:
			return False


	def doReproduce(self, iSeason):
		for pUnit in lGameAnimals:
			iReproduceChance = 0
			#if not pUnit.isAnimal(): return
			if pUnit.isDead(): 
				lGameAnimals.remove(pUnit)
				continue
			try:
				works = pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_COMBAT1"))
			except:
				continue
			if pUnit.getY() < gc.getMap().getGridHeight() / 2 and iSeason < 2:
				## Animal is in southern hemisphere and it is winter/fall
				continue
			
			if pUnit.getY() > gc.getMap().getGridHeight() / 2 and iSeason > 1:
				## Animal is in northern hemisphere and it is winter/fall
				continue			
			if pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_REPRODUCE_SMALL")):
				iReproduceChance = self.reproduceSmall
			elif pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_REPRODUCE_MEDIUM")):
				iReproduceChance = self.reproduceMedium
			elif pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_REPRODUCE_BIG")):
				iReproduceChance = self.reproduceBig
			elif pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_REPRODUCE_HUGE")):
				iReproduceChance = self.reproduceHuge
			iReproduceRand = CyGame().getSorenRandNum(100, "chance of reproducing")
			iPlayer = pUnit.getOwner()
			pPlayer = gc.getPlayer(iPlayer)            
			if iReproduceRand < iReproduceChance:
				# find matching terrain near here and spread to there
				keepLooking = True
				iX = pUnit.getX()
				iCurrentX = pUnit.getX()
				iY = pUnit.getY()
				iCurrentY = pUnit.getY()
				pCurrentPlot = gc.getMap().plot(iCurrentX, iCurrentY)
				pNextPlot = pCurrentPlot
				i = 0
				while (keepLooking == True and i < 100):
					##search nearby plots until you get one with same characteristics
					pNextPlot = gc.getMap().plot(iX,iY).getNearestLandPlot()
					if (pNextPlot.getTerrainType() == pCurrentPlot.getTerrainType()) and (pNextPlot.getFeatureType() == pCurrentPlot.getFeatureType()):
						pPlayer.initUnit(pUnit.getUnitType(), pNextPlot.getX(), pNextPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
						keepLooking = False
					else:
						iX = pNextPlot.getX()
						iY = pNextPlot.getY()
						i += 1 ##don't look too hard, if can't find, just stop
				pNewUnit = pPlayer.initUnit(pUnit.getUnitType(),pUnit.getX(), pUnit.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
				lGameAnimals.append(pNewUnit)


		for pUnit in lGamePlants:
			if pUnit.isDead():
				lGamePlants.remove(pUnit)
				return
			iPlayer = pUnit.getOwner()
			pPlayer = gc.getPlayer(iPlayer)             
			## find matching terrain near here and spread to there
			if abs(pUnit.getX()) > gc.getMap().getGridWidth() or abs(pUnit.getY()) > gc.getMap().getGridHeight: continue 
			lSpreadTiles = Spreads.Spreads().spreadNear(pUnit.getX(), pUnit.getY(), 3, iReproduceChance / 10, True) 
			for pPlot in lSpreadTiles:
				if pPlot.isCity(): continue
				if pPlot.getNumUnits() > 0: continue
				pNewPlant = pPlayer.initUnit(pUnit.getUnitType(),pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)   
				lGamePlants.append(pNewPlant)


	def loadAnimals(self):
		fud = 0
		for iPlayer in xrange(gc.getMAX_PLAYERS()):			
			pyPlayer = PyPlayer(iPlayer)
			UnitList = pyPlayer.getUnitList()
			for pUnit in UnitList:   
				if pUnit.isAnimal(): 
					if pUnit.baseCombatStr() > 0:
						lGameAnimals.append(pUnit)
					else:
						lGamePlants.append(pUnit) 


	def checkAnimals(self):
		Fart = True
		for pUnit in lGameAnimals:
			if pUnit.isDead():
				lGameAnimals.remove(pUnit)

		for pPlant in lGamePlants:
			if pPlant.isDead():
				lGamePlants.remove(pPlant)


	def addAnimal(self, pUnit):
		if pUnit.baseCombatStr() > 0:
			lGameAnimals.append(pUnit)		
		else:
			lGamePlants.append(pUnit)		



