from CvPythonExtensions import *
import PyHelpers
gc = CyGlobalContext()
PyInfo = PyHelpers.PyInfo
PyPlayer = PyHelpers.PyPlayer

class Hunting:




	def __init__(self):
		self.iBaseHungerPerTurn = 3 ## this is the damage dealt to each unit each turn
		self.iHarshConditionDmg = 2
		self.lHarshTerrains = [gc.getInfoTypeForString("TERRAIN_SNOW"),gc.getInfoTypeForString("TERRAIN_TUNDRA")]
		self.lHarshFeatures = [gc.getInfoTypeForString("FEATURE_ICE"), gc.getInfoTypeForString("FEATURE_JUNGLE")]
		self.iSuperHarshDmg = 5
		self.lSuperHarshFeatures = [gc.getInfoTypeForString("FEATURE_FALLOUT")]
		self.lSuperHarshTerrains = [gc.getInfoTypeForString("TERRAIN_DESERT")]
		self.iDamageRand = 3

		self.iFoodLarge = 90
		self.iFoodMedium = 50
		self.iFoodSmall = 30
		
		
		## If you don't want hunger to happen, set this line to 1
		self.bDisableHunger = False
		

	def doHunger(self, pUnit, pPlot):
		if not self.bDisableHunger:
			iDamage = self.iBaseHungerPerTurn
			if pPlot.getTerrainType() in self.lHarshTerrains or pPlot.getFeatureType() in self.lHarshFeatures:
				iDamage += self.iHarshConditionDmg
			if pPlot.getTerrainType() in self.lSuperHarshTerrains or pPlot.getFeatureType() in self.lSuperHarshFeatures:
				iDamage += self.iSuperHarshDmg
			iDamage += CyGame().getSorenRandNum(self.iDamageRand, "Randomness")
			pUnit.changeDamage(iDamage, False)

	def doEating(self, pLoser, pWinner):
		iHealth = 0
		if pLoser.isHasPromotion(gc.getInfoTypeForString("PROMOTION_FOOD3")):
			iHealth = self.iFoodLarge
		elif pLoser.isHasPromotion(gc.getInfoTypeForString("PROMOTION_FOOD2")):
			iHealth = self.iFoodMedium
		elif pLoser.isHasPromotion(gc.getInfoTypeForString("PROMOTION_FOOD1")):
			iHealth = self.iFoodSmall

		pWinnerPlot = gc.getMap().plot(pWinner.getX(),pWinner.getY())
		for i in range(pWinnerPlot.getX() - 1, pWinnerPlot.getX() + 2):
			for j in range(pWinnerPlot.getY() - 1, pWinnerPlot.getY() + 2):
				pPlot = gc.getMap().plot(i,j)
				for iUnit in range(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(iUnit)
					pUnit.changeDamage(-1*iHealth, False)

