from CvPythonExtensions import *
gc = CyGlobalContext()

class Seasons:
		
	def __init__(self):
		
		## Change these to fit your scenario
		self.iTopLatitude = 90
		self.iBottomLatitude = -90
		
		
		
		
		self.iLength	= 4
		self.Seasons =	["TXT_KEY_SPRING", "TXT_KEY_SUMMER", "TXT_KEY_AUTUMN", "TXT_KEY_WINTER"]

		## Lol I don't use this at all anymore
		self.lSeasons =[	["IMPROVEMENT_FORT", "YIELD_FOOD", 0, 2, 1, -2],
				["IMPROVEMENT_FORT", "YIELD_COMMERCE", 0, -1, 1, 2],
				["IMPROVEMENT_FORT", "YIELD_PRODUCTION", 0, 1, 0, -1]]


		## Later I might expand this to quickly determine climates and do things like wet/dry season, changing ITCZ, etc.
		## But for now, just apply winter terrain according to latitudes.
		self.GrassWinterTerrain = "TERRAIN_WINTER_GRASS"
		self.PlainsWinterTerrain = "TERRAIN_WINTER_PLAINS"
		self.PeakWinterTerrain = "TERRAIN_WINTER_PEAK"
		self.ForestWinterFeature = "FEATURE_WINTER_FOREST"
		self.TundraWinterTerrain = "TERRAIN_WINTER_TUNDRA"

		self.iWinterSnowChance = 120
		self.minSnowLatitude = 30
		self.iSpringSnowChance = 10
		self.iSummerSnowChance = 2
		self.iAutumnSnowChance = 80
		self.iHillBonus = 10
		self.iPeakBonus = 20

		## This will hold all the snow tiles so we can change them back to normal
		self.lWinterTiles = []
		
		## New Globals:
		self.iMaxSnowLine = 80
		self.iMaxSnowSecondLine = 70
		self.iMinSnowLine = 45
		self.iMinSnowSecondLine = 30
		
		#self.iCoastalDistanceDenominator = 80
		#self.iWestCoastBonus = -50
		#self.iEastCoastBonus = -25
		self.iNearElevationBonus = 25
		self.iElevationBonus = 50
		
		self.iSecondLineChance = 50
		


	def adjustLength(self):
		return max(1, (self.iLength * gc.getGameSpeedInfo(CyGame().getGameSpeedType()).getImprovementPercent() / 100))


	#def adjustSeason(self, iLength):
		#iGameTurn = CyGame().getGameTurn()
		#iSeason = (iGameTurn/iLength) % 4
		#iSeason += 2
		#for iTeamX in xrange(gc.getMAX_TEAMS()):
			#pTeamX = gc.getTeam(iTeamX)
			
			### Later need to adjust the improvement changes so that they are not universal; they should only apply to northern and southern hemispheres
			
			#for i in self.lSeasons:
				#pTeamX.changeImprovementYieldChange(gc.getInfoTypeForString(i[0]), gc.getInfoTypeForString(i[1]), i[iSeason])


	#def checkSeasons(self, iGameTurn, iLength):
		###Called every turn
		#iGameTurn += 1
		#if iGameTurn % iLength == 0:##This means time to change seasons
			#iSeason = (iGameTurn/iLength) % 4
			#iSeason += 2
			#iOldSeason = iSeason - 1
			#if iOldSeason == 1:
				#iOldSeason = 5
			#for iTeamX in xrange(gc.getMAX_TEAMS()):
				#pTeamX = gc.getTeam(iTeamX)
				#for i in self.lSeasons:
					#iChange = i[iSeason] - i[iOldSeason]
					##need to add this back in later when improvements become a thing
					##pTeamX.changeImprovementYieldChange(gc.getInfoTypeForString(i[0]), gc.getInfoTypeForString(i[1]), iChange)

	def checkMelting(self, iGameTurn, iLength):
		##CyInterface().addImmediateMessage("Checking melting: ", "")
		## New melting function, this one will go through all the tiles with snow and check whether they should melt or not
		i = 0
		for pPlot in self.lWinterTiles:
			bNorthernHemisphere = False
			if pPlot.getY() > gc.getMap().getGridHeight() / 2:
				bNorthernHemisphere = True
			## This is the key: I'm just using snow chance, but for the opposite season. 
			iMeltSeason = ((iGameTurn / iLength) % 4) + 2
			if iMeltSeason > 3:
				iMeltSeason -= 4
			iMeltChance = self.getSnowChance(bNorthernHemisphere, iGameTurn, iMeltSeason, iLength)
			iMeltRand = CyGame().getSorenRandNum(100, "Chance of snow melting")
			iTerrainType = pPlot.getTerrainType()
			iFeatureType = pPlot.getFeatureType()
			if iMeltRand < iMeltChance:
				i += 1
				##CyInterface().addImmediateMessage("plot x %d y %d should have melted" % (pPlot.getX(), pPlot.getY()),"")
				if iTerrainType == gc.getInfoTypeForString(self.PlainsWinterTerrain):
					pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_PLAINS"),False,True)
				elif iTerrainType == gc.getInfoTypeForString(self.GrassWinterTerrain):
					pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_GRASS"),False,True)
				elif iTerrainType == gc.getInfoTypeForString(self.PeakWinterTerrain):
					pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_PEAK"),False,True)
				if iFeatureType == gc.getInfoTypeForString(self.ForestWinterFeature):
					iFeatureVariety = pPlot.getFeatureVariety()
					pPlot.setFeatureType(gc.getInfoTypeForString("FEATURE_FOREST"),iFeatureVariety)
		##CyInterface().addImmediateMessage("Melted %d tiles" % i, "")
			
	
	def doSnowing(self, pPlot, iGameTurn, iSeason, iLength):
		iPlotY = pPlot.getY()
		
		bSnowed = False
		bNorthernHemisphere = True
		iLatitude = self.getTileLatitude(iPlotY)
		if iLatitude > 0:
			bNorthernHemisphere = True
		else:
			bNorthernHemisphere = False
		#if iPlotY == 27:
			#CyInterface().addImmediateMessage("the plot at y27 returns latitude %d" % iLatitude, "")
		#if iPlotY == 98:
			#CyInterface().addImmediateMessage("the plot at y98 returns latitude %d" % iLatitude, "")
		#if iPlotY == 50:
			#CyInterface().addImmediateMessage("the plot at y50 returns latitude %d" % iLatitude, "")
		iSnowLine = 90
		iSnowSecondLine = 90
		if bNorthernHemisphere:
			iSnowLine = self.getSnowLine(iGameTurn, iLength)
			#CyInterface().addImmediateMessage("iSnowLine is %d" % iSnowLine,"")
			iSnowSecondLine = self.getSnowLine(iGameTurn, iLength, True)
		else:
			iSnowLine = self.getSnowLine(iGameTurn + (iLength * 2), iLength)
			iSnowSecondLine = self.getSnowLine(iGameTurn + (iLength * 2), iLength, True)
		if abs(iLatitude) > iSnowLine:
			#CyInterface().addImmediateMessage("message 1","")
			bSnowed = True
		elif abs(iLatitude) > iSnowSecondLine:
			#CyInterface().addImmediateMessage("message 2","")
			iDist = abs(iLatitude) - iSnowSecondLine
			fSnowChance = self.iSecondLineChance + float((iDist / (100 - self.iSecondLineChance)))
			
			##This is where you can add modifiers to put snow on higher elevations and stuff
			if pPlot.isHills():
				fSnowChance += self.iElevationBonus
			if pPlot.isPeak():
				fSnowChance += (2*self.iElevationBonus)
			
			SnowRand = CyGame().getSorenRandNum(100, "chance of snowing here")
			if SnowRand < fSnowChance:
				#CyInterface().addImmediateMessage("message 3","")
				
				bSnowed = True
		
		
		iTerrainType = pPlot.getTerrainType()
		iFeatureType = pPlot.getFeatureType()
		## Now if it snowed, it snows, if it didn't snow, it melts
		bActuallyDidSnow = False
		if bSnowed:
			#CyInterface().addImmediateMessage("message 4","")
			
			if iTerrainType == gc.getInfoTypeForString("TERRAIN_PLAINS"):
				pPlot.setTerrainType(gc.getInfoTypeForString(self.PlainsWinterTerrain),False,True)
				bActuallyDidSnow = True
			elif iTerrainType == gc.getInfoTypeForString("TERRAIN_GRASS"):
				pPlot.setTerrainType(gc.getInfoTypeForString(self.GrassWinterTerrain),False,True)
				bActuallyDidSnow = True
			elif iTerrainType == gc.getInfoTypeForString("TERRAIN_TUNDRA"):
				pPlot.setTerrainType(gc.getInfoTypeForString(self.TundraWinterTerrain),False,True)
				bActuallyDidSnow = True
			elif iTerrainType == gc.getInfoTypeForString("TERRAIN_PEAK"):
				pPlot.setTerrainType(gc.getInfoTypeForString(self.PeakWinterTerrain),False,True)
				bActuallyDidSnow = True
			if iFeatureType == gc.getInfoTypeForString("TERRAIN_FOREST"):
				bActuallyDidSnow = True
				iFeatureVariety = pPlot.getFeatureVariety()
				pPlot.setFeatureType(gc.getInfoTypeForString(self.ForestWinterFeature), iFeatureVariety)
		else:
			##CyInterface().addImmediateMessage("message 5","")
			
			if iTerrainType == gc.getInfoTypeForString(self.PlainsWinterTerrain):
				pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_PLAINS"),False,True)
			elif iTerrainType == gc.getInfoTypeForString(self.GrassWinterTerrain):
				pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_GRASS"),False,True)
			elif iTerrainType == gc.getInfoTypeForString(self.TundraWinterTerrain):
				pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_TUNDRA"),False,True)
			elif iTerrainType == gc.getInfoTypeForString(self.PeakWinterTerrain):
				pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_PEAK"),False,True)
			if iFeatureType == gc.getInfoTypeForString(self.ForestWinterFeature):
				iFeatureVariety = pPlot.getFeatureVariety()
				pPlot.setFeatureType(gc.getInfoTypeForString("FEATURE_FOREST"),iFeatureVariety)
		#if bActuallyDidSnow:
			#CyInterface().addImmediateMessage("The problem is likely a terrain thing","")
		#elif bSnowed:
			#CyInterface().addImmediateMessage("It's never getting to the terrain if statements","")
				
				
	def getTileLatitude(self, iPlotY):
		mMap = gc.getMap()
		iHeight = mMap.getGridHeight()
		fPercentUp = float(float(iPlotY) / float(iHeight))
		#if fPercentUp > 0:
			#CyInterface().addImmediateMessage("there has been a case that worked: fpercentup is %f" % fPercentUp, "")
		iTotalLatitude = self.iTopLatitude - self.iBottomLatitude
		iThisLatitude = (fPercentUp * iTotalLatitude) + self.iBottomLatitude
		##CyInterface().addImmediateMessage("iHeight %d, fPercentUp %d, iTotalLatitude %d, iThisLatitude %d" % (iHeight, fPercentUp, iTotalLatitude, iThisLatitude),"")
		return iThisLatitude
		
	def getSnowLine(self, iGameTurn, iLength, bSecond = False):
		iWhichTurn = 0
		iDirection = 1
		iTurnsSinceStart = (iGameTurn + 1) % iLength
		iSeason = ((iGameTurn+1)/iLength)%4
		iSnowStartLine = 0
		iSnowSecondStartLine = 0
		if iSeason == 1 and iTurnsSinceStart < (iLength / 2) + 1:
			## this means it is since winter, and snow is receding
			iWhichTurn = self.getTurnsSinceWinter(iGameTurn, iLength)
			iDirection = 1
			iSnowStartLine = self.iMinSnowLine
			iSnowSecondStartLine = self.iMinSnowSecondLine
		elif (iSeason == 1) or (iSeason == 2) or ((iSeason == 3) and iTurnsSinceStart < (iLength / 2) + 1):
			## this means it is since summer, and snow is building
			iWhichTurn = self.getTurnsSinceSummer(iGameTurn, iLength)
			iDirection = -1
			iSnowStartLine = self.iMaxSnowLine
			iSnowSecondStartLine = self.iMaxSnowSecondLine			
		else:
			## this means it is not summer, it is not fall, and it is not the beginning of winter
			## therefore it is measured since winter began, and snow is receding			
			iWhichTurn = self.getTurnsSinceWinter(iGameTurn, iLength)
			iDirection = 1
			iSnowStartLine = self.iMinSnowLine
			iSnowSecondStartLine = self.iMinSnowSecondLine			
		iSnowLine = -1
		if bSecond:
			iSnowLine = iSnowSecondStartLine + iDirection * (((self.iMaxSnowSecondLine - self.iMinSnowSecondLine)/(iLength * 2))*iWhichTurn)
		else:
			iSnowLine = iSnowStartLine + iDirection * (((self.iMaxSnowLine - self.iMinSnowLine)/(iLength * 2))*iWhichTurn)
			#CyInterface().addImmediateMessage("calculating difference %d over length %d times turn %d times direction %d" % (self.iMaxSnowLine - self.iMinSnowLine,iLength*2,iWhichTurn,iDirection),"")
		#CyInterface().addImmediateMessage("snow line is %d" % iSnowLine,"")
		return iSnowLine
			

	def getTurnsSinceSummer(self, iGameTurn, iLength):
		iSeason = ((iGameTurn + 1)/iLength) % 4
		iTurnsSinceStart = (iGameTurn + 1) % iLength
		iMiddleTurn = (iLength / 2) + 1
		iSeasonsSinceSummer = iSeason - 1
		iTurns = 0
		if iSeason == 1:
			iTurns = iTurnsSinceStart - iMiddleTurn
		elif iSeasonsSinceSummer == 1:
			iTurns = iTurnsSinceStart + (iLength - iMiddleTurn)			
		elif iSeasonsSinceSummer == 2:
			iTurns = iTurnsSinceStart + iLength + (iLength - iMiddleTurn)			
		else:
			return -1
		return iTurns
	
	def getTurnsSinceWinter(self, iGameTurn, iLength):
		iSeason = ((iGameTurn + 1)/iLength) % 4
		iTurnsSinceStart = (iGameTurn + 1) % iLength
		iMiddleTurn = (iLength / 2) + 1
		iSeasonsSinceWinter = iSeason - 3
		iTurns = 0
		if iSeason == 3:
			iTurns = iTurnsSinceStart - iMiddleTurn			
		elif iSeasonsSinceWinter == -3:
			iTurns = iTurnsSinceStart + (iLength - iMiddleTurn)			
		elif iSeasonsSinceWinter == -2:
			iTurns = iTurnsSinceStart + iLength + (iLength - iMiddleTurn)			
		else:
			return -1
		return iTurns
	
	
	def getSnowChance(self, bNorthernHemisphere, iGameTurn, iSeason, iLength):
		iSnowChance = 0
		if not bNorthernHemisphere:
			iSeason += 2
		if iSeason > 3:
			iSeason -= 4
		if iSeason == 0:  ##Spring
			iSnowChance = self.iSpringSnowChance - 5*(iGameTurn % iLength)
		##snow gets lower as spring progresses
		if iSeason == 1:  ##Summer
			if (iGameTurn % iLength) < (iLength / 2):
				##summer gets hotter toward middle
				iSnowChance = self.iSummerSnowChance - 5*(iGameTurn % iLength)
			else:
				iSnowChance = self.iSummerSnowChance + 2*(iGameTurn % iLength)
		if iSeason == 2: ##fall
			iSnowChance = self.iAutumnSnowChance + 3*(iGameTurn % iLength)
			##fall gets colder as it goes on
		if iSeason == 3: ##winter
			##winter just gets colder as it goes
			iSnowChance = self.iWinterSnowChance + (iGameTurn % iLength)
		if iSnowChance < 0:
			iSnowChance = 0
		
			
		
		return iSnowChance




	##Snowfall
	def doSnowfall(self, iGameTurn, pPlot, iSnowChance, iSeason):
		##From the intialization we have a top latitude and bottom latitude.
		iLatitude = abs(pPlot.getLatitude())
		iUsefulLatitude = iLatitude - self.minSnowLatitude
		if (iUsefulLatitude > 0):
			iPeakBonus = 0
			iHillBonus = 0
			if (pPlot.isPeak()):
				iPeakBonus = self.iPeakBonus
			elif (pPlot.isHills()):
				iHillBonus = self.iHillBonus

			iSnowChance += (iHillBonus + iPeakBonus)
			fMaxLatitude = 90.0 - float(self.minSnowLatitude)
			fSnowChance = float(iSnowChance)
			fLatitudeMultiplier = float(iUsefulLatitude) / fMaxLatitude
			iSnowChance = int(fSnowChance * fLatitudeMultiplier)
			#iMeltChance = (100 - iSnowChance) / 2
			iTerrainType = pPlot.getTerrainType()
			iFeatureType = pPlot.getFeatureType()
			iFeatureVariety = pPlot.getFeatureVariety()
			
			##New bit adding more chance of having snow if adjacent tiles have snow, 10% per tile (so snow won't be so sporadic)
			iX = pPlot.getX()
			iY = pPlot.getY()
			fAdjacentMultiplier = 1.0
			mMap = gc.getMap()
			for x in range(iX - 1, iX + 2):
				for y in range(iY - 1, iY + 2):
					if mMap.isPlot(x,y):
						pAdjacentPlot = mMap.plot(x,y)
						if pAdjacentPlot.getTerrainType() == gc.getInfoTypeForString(self.PlainsWinterTerrain) or pAdjacentPlot.getTerrainType() == gc.getInfoTypeForString(self.GrassWinterTerrain) or pAdjacentPlot.getTerrainType() == gc.getInfoTypeForString(self.PeakWinterTerrain):
							fAdjacentMultiplier += 0.1
			fSnowChance = float(iSnowChance)*fAdjacentMultiplier
			iSnowChance = int(fSnowChance)
			
			iSnowRand = CyGame().getSorenRandNum(100, "Chance of snow falling")
			if iSnowRand < iSnowChance:
				self.lWinterTiles.append(pPlot)
				if iTerrainType == gc.getInfoTypeForString("TERRAIN_PLAINS"):
					pPlot.setTerrainType(gc.getInfoTypeForString(self.PlainsWinterTerrain),False,True)
				elif iTerrainType == gc.getInfoTypeForString("TERRAIN_GRASS"):
					pPlot.setTerrainType(gc.getInfoTypeForString(self.GrassWinterTerrain),False,True)
				elif iTerrainType == gc.getInfoTypeForString("TERRAIN_PEAK"):
					pPlot.setTerrainType(gc.getInfoTypeForString(self.PeakWinterTerrain),False,True)
				if iFeatureType == gc.getInfoTypeForString("TERRAIN_FOREST"):
					pPlot.setFeatureType(gc.getInfoTypeForString(self.ForestWinterFeature), iFeatureVariety)


			#iMeltSeason = iSeason + 2
			#if iMeltSeason > 3:
				#iMeltSeason -= 4
			#iMeltChance = self.getSnowChance(bNorthernHemisphere, iGameTurn, iMeltSeason, iLength)
			iMeltChance = (100 - iSnowChance) / 2
			iTerrainType = pPlot.getTerrainType()
			iFeatureType = pPlot.getFeatureType()
			iMeltRand = CyGame().getSorenRandNum(100, "Chance of snow falling")
			if iMeltRand < iMeltChance:
				##CyInterface().addImmediateMessage("plot x %d y %d should have melted" % (pPlot.getX(), pPlot.getY()),"")
				if iTerrainType == gc.getInfoTypeForString(self.PlainsWinterTerrain):
					pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_PLAINS"),False,True)
				elif iTerrainType == gc.getInfoTypeForString(self.GrassWinterTerrain):
					pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_GRASS"),False,True)
				elif iTerrainType == gc.getInfoTypeForString(self.PeakWinterTerrain):
					pPlot.setTerrainType(gc.getInfoTypeForString("TERRAIN_PEAK"),False,True)
				if iFeatureType == gc.getInfoTypeForString(self.ForestWinterFeature):
					iFeatureVariety = pPlot.getFeatureVariety()
					pPlot.setFeatureType(gc.getInfoTypeForString("FEATURE_FOREST"),iFeatureVariety)



