
from CvPythonExtensions import *
import PyHelpers
gc = CyGlobalContext()
PyInfo = PyHelpers.PyInfo

class Spreads:

    def __init__(self):
        someVariable = 0
        ## I'm putting this here so that init actually does something
            
    ## This function loops through nearby tiles and adds them to a list and returns it
    def spreadNear(self, iX, iY, iMaxDistance, iSpreadChance, bSameTileType = False, iCityWeight = 0, lFeatures = [-1], lFeatureWeights = [0], lImprovements = [-1], lImprovementWeights = [0], lTerrains = [-1], lTerrainWeights = [0]):
        mMap = gc.getMap()
        pPlot = mMap.plot(iX, iY)
        spreadTiles = []
        for X in range(iX - iMaxDistance, iX + iMaxDistance):
            for Y in range(iY - iMaxDistance, iY + iMaxDistance):
                pPickedPlot = mMap.plot(X, Y)
                if not mMap.isPlot(X, Y): continue
                elif pPickedPlot.at(iX, iY): continue
                elif bSameTileType and not (pPickedPlot.getTerrainType() == pPlot.getTerrainType() and pPickedPlot.getFeatureType() == pPlot.getFeatureType()): continue
                else:
                    iChance = iSpreadChance
                    if pPickedPlot.isCity(): 
                        iChance += iCityWeight
                    if pPickedPlot.getTerrainType() in lTerrains:
                        j = lTerrains.index(pPickedPlot.getTerrainType())
                        iChance += lTerrainWeights[j]
                    if pPickedPlot.getFeatureType() in lFeatures:
                        j = lFeatures.index(pPickedPlot.getFeatureType())
                        iChance += lFeatureWeights[j]                    
                    if pPickedPlot.getImprovementType() in lImprovements:
                        j = lImprovements.index(pPickedPlot.getImprovementType())
                        iChance += lImprovementWeights[j]                    
                spreadVal = CyGame().getSorenRandNum(100, "will it spread to this tile?")
                if spreadVal < iChance:
                    spreadTiles.append(pPickedPlot)
        return spreadTiles





